"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  AsyncAdapter: () => import_node2.AsyncAdapter,
  AsyncProvider: () => import_node2.AsyncProvider,
  FastifySteno: () => FastifySteno,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_node2 = require("@stenodb/node");
var import_fastify_plugin = __toESM(require("fastify-plugin"), 1);

// src/plugin.ts
var import_node = require("@stenodb/node");
var import_class_validator_jsonschema = require("class-validator-jsonschema");
var StenoPlugin = class {
  #fastify;
  #options;
  #db;
  #providers;
  constructor(fastify, options) {
    this.#fastify = fastify;
    this.#options = options;
    this.#db = new import_node.NodeProvider(options);
    this.#providers = /* @__PURE__ */ new Map();
    this.#fastify.decorate("steno", { get: this.getDatabase.bind(this) });
  }
  static async createInstance(fastify, options, done) {
    const db = new StenoPlugin(fastify, options);
    await db.registerDatabases();
    done();
    return db;
  }
  async registerDatabases() {
    this.registerEntities();
    for (const adapter of this.#options.adapters) {
      let provider;
      if (adapter instanceof import_node.AsyncAdapter) {
        provider = await this.#db.create(adapter);
        await provider.read();
      } else {
        throw new TypeError("Invalid adapter");
      }
      this.addSchema(adapter.entity);
      this.#providers.set(adapter.fileName, provider);
    }
  }
  registerEntities() {
    if (!this.#options.entities)
      return;
    for (const entity of this.#options.entities) {
      this.addSchema(entity);
    }
  }
  addSchema(entity) {
    if (this.#fastify.getSchema(entity.name))
      return;
    const schema = (0, import_class_validator_jsonschema.targetConstructorToSchema)(
      entity,
      this.#options.entityOptions
    );
    if (!schema.properties)
      return;
    this.#fastify.addSchema({ ...schema, $id: entity.name });
  }
  getDatabase(name) {
    return this.#providers.get(name);
  }
};

// src/index.ts
var FastifySteno = (0, import_fastify_plugin.default)(StenoPlugin.createInstance, {
  name: "@stenodb/fastify",
  fastify: "4.x"
});
var src_default = StenoPlugin.createInstance;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AsyncAdapter,
  AsyncProvider,
  FastifySteno
});
